#!/usr/bin/env python
# _*_ coding: iso-8859-1 _*_


#import win32api as wa
#import win32con as wc
#import win32ui as wu
#import win32gui as wg

import os
import logging

#import reg
from render_image import renderImage
from gtk.gdk import screen_width, screen_height
import gconf
#from gtk import Warning as gtkWarning
#import warnings
#warnings.simplefilter('error', gtkWarning)


##################
## Fond d'cran ##
##################
conf_client = gconf.client_get_default()
def del_backgrnd(outbg):
    if os.path.isfile(outbg): os.unlink(outbg)
    
def set_backgrnd(sid, message): #, outbg):
    """<message> est une liste, crit 1 item par ligne
    en haut  droite sur le fond d'cran de <sid>
    """
    outbg = '$HOME/.cliscribe_bg.png'
    outbg = os.path.expandvars(os.path.expanduser(outbg))
    try:
        bg = conf_client.get_string('/desktop/gnome/background/picture_filename')
    except:
        logging.debug("Aucun fond d'ecran")
        return
    if outbg == bg:
       try:
            bg = conf_client.get_string ('/desktop/eole/background/old_picture_filename')
       except:
           logging.debug("Aucun fond d'ecran")
           return
    else:
        conf_client.set_string ('/desktop/eole/background/old_picture_filename', bg);


    logging.debug('Utilisation de "%s"'%bg)
    logging.debug("Mise en place du fond d'ecran sid=%s message=%s"%(sid, message))
    logging.debug('RenderImage args : %s'%[bg, outbg, get_format(sid), message, get_backgrnd_color(), get_resolution()])
    renderImage(bg, outbg, get_format(sid), message, get_backgrnd_color(), get_resolution())
#    reg.addreg('HKEY_USERS', bgkey, reg._winreg.REG_SZ, 'Wallpaper', outbg)
    conf_client.set_string ('/desktop/gnome/background/picture_filename', outbg);
    conf_client.set_string ('/desktop/gnome/background/picture_options', 'zoom');

def test_backgrnd(inbg, outbg, message):
    """<message> est une liste, crit 1 item par ligne
    en haut  droite sur le fond d'cran de <sid>
    """
    logging.debug('Utilisation de "%s"'%inbg)
    renderImage(inbg, outbg, 'etendre', message,) # get_backgrnd_color(), get_resolution())
##    reg.addreg('HKEY_USERS', bgkey, reg._winreg.REG_SZ, 'Wallpaper', outbg)
##    apply_wallpaper(sid)

def get_resolution():
    """renvoie la rsolution de l'affichage
    """
#    hor = wu.GetDeviceCaps(wg.GetDC(0), wc.HORZRES)
#    ver = wu.GetDeviceCaps(wg.GetDC(0), wc.VERTRES)
    hor = screen_width()
    ver = screen_height()
    if hor == 0:
        hor = 1024
        ver = 768
    return (hor, ver)

def get_backgrnd_color():
    """Retourne le code couleur du fond sans image
    """
    cdef="#8f4a1c"
#    c = '%06X'%wa.GetSysColor(wc.COLOR_DESKTOP)
#    return '#%s%s%s'%(c[4:6], c[2:4], c[0:2])
    c = conf_client.get_string('/desktop/gnome/background/primary_color')
    if c[0] != '#':
        return cdef
    if len(c) == 13:
        return '#%s%s%s'%(c[1:3],c[5:7],c[9:11])
    if len(c) == 7:
        return c
    return cdef
#    return '#000000'

def get_format(sid):
    """retourne le mode d'affichage du BG
    """
    tile = conf_client.get_string('/desktop/gnome/background/picture_options')
#    bgkey = r'%s\Control Panel\Desktop'%sid
#    style = reg.get_option(bgkey, 'WallpaperStyle', 'HKEY_USERS')
#    tile = reg.get_option(bgkey, 'TileWallpaper', 'HKEY_USERS')
    if tile == 'wallpaper': return "mosaique"
    if tile == 'centered' : return "centre"
    return "etendre"
